from scipy import stats
import numpy as np

def mean_values(bname,bwd,inpflag,fres,fsmin,fsmax,Ca,Ra,pwr):
    Cab=[[],[]]
    Rab=[[],[]]
    pwb=[[],[]]
    bcnt=[[],[]]
    fbin=[[],[]]

    if bname == 'All-Bands':
        # group the data in separated three bands for Y+ and Y- antenna
        frlt=[[],[],[],[],[],[]]   #list of 6 lists
        Calt=[[],[],[],[],[],[]]
        Ralt=[[],[],[],[],[],[]]
        pwlt=[[],[],[],[],[],[]]

        for i in range(len(fres[0])):
            # --- three bands for Y+ 1st harmonic
            if fres[0][i] < 5.0:
                kb=0
            elif fres[0][i] > 7.0 and fres[0][i] < 12.0:
                kb=1
            elif fres[0][i] > 20.0:
                kb=2

            frlt[kb].append(fres[0][i])
            Calt[kb].append(Ca[0][i])
            Ralt[kb].append(Ra[0][i]/1.0e3)
            pwlt[kb].append(pwr[0][i])

            # --- three bands for Y- 1st harmonic
            if fres[1][i] < 5.0:
                kb=3
            elif fres[1][i] > 7.0 and fres[1][i] < 12.0:
                kb=4
            elif fres[1][i] > 20.0:
                kb=5

            frlt[kb].append(fres[1][i])
            Calt[kb].append(Ca[1][i])
            Ralt[kb].append(Ra[1][i]/1.0e3)
            pwlt[kb].append(pwr[1][i])

        # --- bin the data in three bands, each for Y+ and y- monopole
        for i in range(3):
            fminlt=min(frlt[i])
            fmaxlt=max(frlt[i])

            nbin=int((fmaxlt-fminlt)/bwd)
 
            stat1=stats.binned_statistic(frlt[i], Calt[i], 'sum', bins=nbin)
            bsum1=stat1[0]
            stat1=stats.binned_statistic(frlt[i], Calt[i], 'mean', bins=nbin)
            stat2=stats.binned_statistic(frlt[i], Ralt[i], 'mean', bins=nbin)
            stat3=stats.binned_statistic(frlt[i], pwlt[i], 'mean', bins=nbin)

            stat4=stats.binned_statistic(frlt[i+3], Calt[i+3], 'sum', bins=nbin)
            bsum2=stat4[0]
            stat4=stats.binned_statistic(frlt[i+3], Calt[i+3], 'mean', bins=nbin)
            stat5=stats.binned_statistic(frlt[i+3], Ralt[i+3], 'mean', bins=nbin)
            stat6=stats.binned_statistic(frlt[i+3], pwlt[i+3], 'mean', bins=nbin)

            if i == 0:
                if inpflag == 'In':
                    lj=0
                    hj=4
                else:
                    lj=2
                    hj=0
            if i == 1:
                lj=3
                hj=7
            elif i == 2:
                if inpflag == 'In':
                    lj=12
                    hj=14
                else:
                    lj=13
                    hj=10

            for j in range(lj,nbin-hj):
                Cab[0].append(stat1[0][j])
                bcnt[0].append(bsum1[j]/stat1[0][j])
                Rab[0].append(stat2[0][j])
                pwb[0].append(stat3[0][j])

                fbin[0].append(0.5*(stat1[1][j]+stat1[1][j+1]))

                Cab[1].append(stat4[0][j])
                bcnt[1].append(bsum2[j]/stat4[0][j])
                Rab[1].append(stat5[0][j])
                pwb[1].append(stat6[0][j])

                fbin[1].append(0.5*(stat4[1][j]+stat4[1][j+1]))
    else:
        nbin=int((fsmax[0]-fsmin[0])/bwd)
        stat1=stats.binned_statistic(fres[0], Ca[0], 'sum', bins=nbin)
        bsum=stat1[0]
        stat=stats.binned_statistic(fres[0], Ca[0], 'mean', bins=nbin)
        Cab[0]=stat[0]
        bcnt[0]=bsum/Cab[0]

        #Iaam=np.sqrt(pwr[0:i]/Ra[0:i])
        stat=stats.binned_statistic(fres[0], Ra[0], 'mean', bins=nbin)
        Rab[0]=stat[0]

        #-------- binned radiation power ------
        stat=stats.binned_statistic(fres[0], pwr[0], 'mean', bins=nbin)
        pwb[0]=stat[0]

        for j in range(0,nbin):
            fbin[0][j]=0.5*(stat1[1][j]+stat1[1][j+1])

        nbin=int((fsmax[1]-fsmin[1])/bwd)
        stat2=stats.binned_statistic(fres[1], Ca[1], 'sum', bins=nbin)
        bsum=stat2[0]
        stat=stats.binned_statistic(fres[1], Ca[1], 'mean', bins=nbin)
        Cab[1]=stat[0]
        bcnt[1]=bsum/Cab[1]

        #Iaam=np.sqrt(pwr[0:i]/Ra[0:i])
        stat=stats.binned_statistic(fres[1], Ra[1], 'mean', bins=nbin)
        Rab[1]=stat[0]

        #-------- binned radiation power ------
        stat=stats.binned_statistic(fres[1], pwr[1], 'mean', bins=nbin)
        pwb[1]=stat[0]

        for j in range(0,nbin):
            fbin[1][j]=0.5*(stat2[1][j]+stat2[1][j+1])

        if bname == 'High-Band' and inpflag == 'In':
            lj=6
            hj=16
        elif bname == 'High-Band' and inpflag == 'Out':
            lj=1
            hj=0
        else:
            lj=0
            hj=0

        fbin[1]=fbin[1][lj:nbin-hj]
        Cab[1]=Cab[1][lj:nbin-hj]
        Rab[1]=Rab[1][lj:nbin-hj]
        pwb[1]=pwb[1][lj:nbin-hj]
        bcnt[1]=bcnt[1][lj:nbin-hj]

        fbin[0]=fbin[0][lj:nbin-hj]
        Cab[0]=Cab[0][lj:nbin-hj]
        Rab[0]=Rab[0][lj:nbin-hj]
        pwb[0]=pwb[0][lj:nbin-hj]
        bcnt[0]=bcnt[0][lj:nbin-hj]

    return Cab, Rab, pwb, bcnt, fbin